﻿using System;

namespace ArrayManipulationExample
{
    class Program
    {
        static void Main()
        {
            int[] numbers = new int[5];
            int length = 0;

            Console.WriteLine("iNetTutor.com - Array Manipulation Example");
            Console.WriteLine("This is an example of array manipulation on integers only");
            while (true)
            {
                Console.WriteLine("\nChoose an operation:");
                Console.WriteLine("1. Insert an element");
                Console.WriteLine("2. Update an element");
                Console.WriteLine("3. Delete an element");
                Console.WriteLine("4. Print the array");
                Console.WriteLine("5. Exit");

                Console.Write("Enter your choice: ");
                int choice = Convert.ToInt32(Console.ReadLine());

                if (choice == 1)
                {
                    Console.Write("Enter the index where you want to insert the element: ");
                    int index = Convert.ToInt32(Console.ReadLine());

                    Console.Write("Enter the value to insert: ");
                    int value = Convert.ToInt32(Console.ReadLine());

                    if (index < 0 || index > length)
                    {
                        Console.WriteLine("Invalid index!");
                    }
                    else
                    {
                        InsertElement(numbers, ref length, index, value);
                        Console.WriteLine("Element inserted successfully!");
                    }
                }
                else if (choice == 2)
                {
                    Console.Write("Enter the index of the element to update: ");
                    int index = Convert.ToInt32(Console.ReadLine());

                    Console.Write("Enter the new value: ");
                    int value = Convert.ToInt32(Console.ReadLine());

                    if (index < 0 || index >= length)
                    {
                        Console.WriteLine("Invalid index!");
                    }
                    else
                    {
                        UpdateElement(numbers, index, value);
                        Console.WriteLine("Element updated successfully!");
                    }
                }
                else if (choice == 3)
                {
                    Console.Write("Enter the index of the element to delete: ");
                    int index = Convert.ToInt32(Console.ReadLine());

                    if (index < 0 || index >= length)
                    {
                        Console.WriteLine("Invalid index!");
                    }
                    else
                    {
                        DeleteElement(numbers, ref length, index);
                        Console.WriteLine("Element deleted successfully!");
                    }
                }
                else if (choice == 4)
                {
                    Console.WriteLine("Array elements:");
                    PrintArray(numbers, length);
                }
                else if (choice == 5)
                {
                    Console.WriteLine("Exiting the program...");
                    break;
                }
                else
                {
                    Console.WriteLine("Invalid choice! Please try again.");
                }
            }
        }

        static void InsertElement(int[] array, ref int length, int index, int element)
        {
            for (int i = length - 1; i >= index; i--)
            {
                array[i + 1] = array[i];
            }

            array[index] = element;
            length++;
        }

        static void UpdateElement(int[] array, int index, int newValue)
        {
            array[index] = newValue;
        }

        static void DeleteElement(int[] array, ref int length, int index)
        {
            for (int i = index; i < length - 1; i++)
            {
                array[i] = array[i + 1];
            }

            length--;
        }

        static void PrintArray(int[] array, int length)
        {
            for (int i = 0; i < length; i++)
            {
                Console.Write(array[i] + " ");
            }
            Console.WriteLine();
        }
    }
}